# Poco::Prometheus

# class Exporter

Library: Prometheus
Package: Core
Header: Poco/Prometheus/Exporter.h

## Description

The Exporter interface is used to format and write metrics to an output stream.

## Inheritance

Known Derived Classes: TextExporter

## Member Summary

Member Functions: operator =, writeHeader, writeSample

## Constructors

### Exporter

Exporter() = default;

### Exporter

Exporter(
const Exporter & param420
) = delete;

### Exporter

Exporter(
Exporter && param421
) = delete;

## Destructor

### ~Exporter

virtual ~Exporter() = default;

## Member Functions

### writeHeader

virtual void writeHeader(
const Metric & metric
) = 0;

Writes the header (HELP and TYPE in text format).

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
float value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
double value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
Poco::UInt32 value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
Poco::Int32 value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
Poco::UInt64 value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
Poco::Int64 value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### writeSample

virtual void writeSample(
const Metric & metric,
const std::vector < std::string > & labelNames,
const std::vector < std::string > & labelValues,
const std::string & value,
const Poco::Timestamp & timestamp = 0
) = 0;

Writes a sample for the given metric and the given labels.

### operator =

Exporter & operator = (
const Exporter & param422
) = delete;

### operator =

Exporter & operator = (
Exporter && param423
) = delete;